/* ============================================================
* Author:       liubingsheng
* Time:         2016/11/29 14:52:25
* FileName:     RedisSystem
* Purpose:      Redis
* =============================================================*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;

namespace Utility
{
    /// <summary>
    /// Random扩展
    /// </summary>
    public static class RandomExtension
    {

        public static double RandomDouble(this Random self, double dMax)
        {
            double value = self.NextDouble();
            return dMax * value;
        }

        public static double RandomDouble(this Random self, double min, double max)
        {
            double value = self.NextDouble();
            return min + (max - min) * value;
        }

        public static float RandomFloat(this Random self, float fMax)
        {
            return (float)self.RandomDouble(fMax);
        }

        public static float RandomFloat(this Random self, float min, float max)
        {
            return (float)self.RandomDouble(min, max);
        }

        /// <summary>
        /// 随机一个小于maxValue的Int值
        /// </summary>
        /// <param name="self"></param>
        /// <param name="dMax"></param>
        /// <returns></returns>
        public static int RandomInt(this Random self, int maxValue)
        {
            return self.Next(maxValue);
        }

        public static int RandomInt(this Random self, int minValue, int maxValue)
        {
            return self.Next(minValue, maxValue);
        }

        /// <summary>
        /// 是否命中
        /// </summary>
        /// <param name="value"></param>
        /// <returns></returns>
        public static bool IsHit(this Random self, int value)
        {
            return self.RandomInt(100) < value;
        }
    }
}
